package com.example.proyectofinal;

import java.util.Vector;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Canvas;
import android.graphics.Paint.Style;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.OvalShape;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;


public class VistaJuego extends View {
	// //// MULTIMEDIA //////
	SoundPool soundPool;
	int win;
	////electrones/////
	private int numelectro,puntuacion;
	private Grafico nucleo;
	private ShapeDrawable  drawablenucleo;
	private int cont = 0;
	  private Vector<Grafico> electrones;
	  private int PERIODO_PROCESO;
	private ShapeDrawable drawableelectron[]= new ShapeDrawable[12];
	 // Thread encargado de procesar el juego
	 private ThreadJuego thread = new ThreadJuego();
	int[] rainbow;
	 private long ultimoProceso = 0;
	private SharedPreferences pref;
	 
	 
	public VistaJuego(Context context, AttributeSet attrs) {
		super(context, attrs);
		soundPool = new SoundPool( 5, AudioManager.STREAM_MUSIC , 0);
		win = soundPool.load(context, R.raw.win,0);
		 pref = PreferenceManager.getDefaultSharedPreferences(context);
		 String num;
		 num = pref.getString("circulos", "7");
	     int foo = Integer.parseInt(num);
 		  numelectro = foo;
		   rainbow = context.getResources().getIntArray(R.array.rainbow);
			electrones = new Vector<Grafico>();
			ShapeDrawable dnucleo= new ShapeDrawable(new OvalShape());
         	dnucleo.getPaint().setColor(rainbow[cont]);
			dnucleo.getPaint().setStrokeWidth(8);
			dnucleo.getPaint().setStyle(Style.FILL_AND_STROKE);
			dnucleo.setIntrinsicHeight(50);
			dnucleo.setIntrinsicWidth(50 );
			drawablenucleo =dnucleo;
			nucleo = new Grafico(this, drawablenucleo);
		    numelectro = Integer.valueOf(pref.getString("circulos", "6"));
		      
			for (int i = 0; i < foo; i++) {
				if (i < 8){
				ShapeDrawable delectron = new ShapeDrawable(new OvalShape());
			
				delectron.getPaint().setColor(rainbow[i]);
				delectron.getPaint().setStrokeWidth(8);
				delectron.getPaint().setStyle(Style.FILL_AND_STROKE);
				delectron.setIntrinsicHeight(90);
				delectron.setIntrinsicWidth(90 );
				drawableelectron[i] = delectron;
				
	                Grafico electron = new Grafico(this,drawableelectron[i]);
	                electron.setIncY(Math.random() * 4 - 2);
	                electron.setIncX(Math.random() * 4 - 2);
	                electron.setAngulo((int) (Math.random() * 360));
	                electron.setRotacion((int) (Math.random() * 8 - 4));
	                electrones.add(electron);}
			else if (i>7) {
				ShapeDrawable delectron = new ShapeDrawable(new OvalShape());
				delectron.getPaint().setColor(rainbow[i-7]);
				delectron.getPaint().setStrokeWidth(8);
				delectron.getPaint().setStyle(Style.FILL_AND_STROKE);
				delectron.setIntrinsicHeight(90);
				delectron.setIntrinsicWidth(90 );
				drawableelectron[i] = delectron;
				 Grafico electron = new Grafico(this,drawableelectron[i]);
	                electron.setIncY(Math.random() * 4 - 2);
	                electron.setIncX(Math.random() * 4 - 2);
	                electron.setAngulo((int) (Math.random() * 360));
	                electron.setRotacion((int) (Math.random() * 8 - 4));
	                electrones.add(electron);
	                
				
			}
			}
	}
	
	


    @Override protected void onSizeChanged(int ancho, int alto,int ancho_anter, int alto_anter) {
          super.onSizeChanged(ancho, alto, ancho_anter, alto_anter);
          // Una vez que conocemos nuestro ancho y alto.
          ultimoProceso = System.currentTimeMillis();
          
          nucleo.setCenX((int) ancho/1.2);
          nucleo.setCenY((int) (alto/15));
          for (Grafico electron: electrones){
        	
        		  electron.setCenX((int) (Math.random() * ancho));
        		  electron.setCenY((int) (Math.random() * alto));
        		  
          }
          ultimoProceso = System.currentTimeMillis();
          thread.start();
    }
    
    @Override protected void  onDraw(Canvas canvas) {
    	   
    	nucleo.dibujaGrafico(canvas);
        for (Grafico electron: electrones) {
            electron.dibujaGrafico(canvas);
        }
  }
    protected void actualizaFisica() {
        long ahora = System.currentTimeMillis();
       if ( pref.getString("velocidad", "1").equals("0")){
    	   PERIODO_PROCESO = 70;
       }
       else if ( pref.getString("velocidad", "1").equals("1")){
    	   PERIODO_PROCESO = 50;
       }
       else if ( pref.getString("velocidad", "1").equals("2")){
    	   PERIODO_PROCESO = 10;
       }
        if (ultimoProceso + PERIODO_PROCESO > ahora) {
              return;      // Salir si el perodo de proceso no se ha cumplido.
        }
        // Para una ejecucin en tiempo real calculamos retardo           
        double retardo = (ahora - ultimoProceso) / PERIODO_PROCESO;
        ultimoProceso = ahora; // Para la prxima vez
        

        
        for (Grafico electron: electrones) {
        
             
           electron.incrementaPos(retardo);



       
 }
    }
    class ThreadJuego extends Thread {
        @Override
        public void run() {
              while (true) {
                     actualizaFisica();
              }
        }
 }

	@Override
    public boolean onTouchEvent(final MotionEvent event) {
        boolean handled = false;

        int xTouch;
        int yTouch;
        int pointerId;
        int actionIndex = event.getActionIndex();
        Grafico electron;

        // get touch event coordinates and make transparent circle from it
        switch (event.getActionMasked()) {
            case MotionEvent.ACTION_DOWN:
              
            	
                xTouch = (int) event.getX(0);
                yTouch = (int) event.getY(0);
                 
                // check if we've touched inside some circle
                
                electron = getTouchedCircle(xTouch, yTouch);
                if (electron != null){
               electron.cleargrafico(electron);
               
               color(electron);
              
               }
                else {
                invalidate();
                handled = true;
                salir();}
                invalidate();
                handled = true;
                break;

            case MotionEvent.ACTION_POINTER_DOWN:
               
                // It secondary pointers, so obtain their ids and check circles
                pointerId = event.getPointerId(actionIndex);

                xTouch = (int) event.getX(actionIndex);
                yTouch = (int) event.getY(actionIndex);

                // check if we've touched inside some circle
                electron = getTouchedCircle(xTouch, yTouch);
                electron.cleargrafico(electron);
                invalidate();
                handled = true;
                break;



            case MotionEvent.ACTION_CANCEL:
                handled = true;
                break;

            default:
                // do nothing
                break;
        }

        return super.onTouchEvent(event) || handled;
    }



	private Activity padre;
	 
	public void setPadre(Activity padre) {
	       this.padre = padre;
	}
	    
	    public void color(Grafico g){
	    	int temp=0;
	    	boolean fl = true;
	    	if (g.getColor() == nucleo.getColor()){
	    		
	    		puntuacion +=10;
	    		g.puntuacion(puntuacion);
	    		soundPool.play(win, 1, 1, 1, 0, 1);
	    		cambiaColor(g);
	    		temp=g.salir(temp, numelectro);
	    		    	}
	    	
	    	
	    	}
	 
	    	
	  
	    
	    
	    public void cambiaColor(Grafico g){
	    	cont=g.numColor(cont, numelectro);
	    
	    	if (g.getColor() == nucleo.getColor()){
	    	  nucleo.Cambiacolor(nucleo, rainbow[cont]);
	    	  nucleo.setColor(rainbow[cont]);
	    	    
	    	
	    	}
	    }

	    
	    private Grafico getTouchedCircle(final int xTouch, final int yTouch) {
	        
              Grafico touched = null;
	        for ( Grafico electron: electrones){
	            if ((electron.getCenX()- xTouch) * (electron.getCenX() - xTouch) + (electron.getCenY() - yTouch) * (electron.getCenY() - yTouch) <= electron.getRadioInval() * electron.getRadioInval()) {
	                touched = electron;
	                break;
	            }
	        }

	        return touched;
	    }

	    private void salir() {
	        Bundle bundle = new Bundle();
           bundle.putInt("puntuacion", puntuacion);
            Intent intent = new Intent();
	        intent.putExtras(bundle);
	        padre.setResult(Activity.RESULT_OK, intent);
	        padre.finish();
	   }
}